<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html" standalone="yes" indent="no" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"/>
  <xsl:template match="/">
    <html>
      <head>
        <title>Natural Style Violations</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <meta http-equiv="pragma" content="no-cache"/>
      </head>
      <body>
        <p>
          <b>Coding Style Check Results</b>
        </p>
        <table border="1" cellspacing="0" cellpadding="2">
          <tr bgcolor="#CCCCCC">
            <th colspan="2">
              <b>Summary</b>
            </th>
          </tr>
          <tr bgcolor="#999999">
            <td>Total files checked</td>
            <td align="center">
              <xsl:number level="any" value="count(/NATstyle/file)"/>
            </td>
          </tr>
          <tr bgcolor="#CCCCCC">
            <td>Files with errors</td>
            <td align="center">
              <xsl:number level="any" value="count(/NATstyle/file[error/@severity ='error'])"/>
            </td>
          </tr>
          <tr bgcolor="#999999">
            <td>Files with info</td>
            <td align="center">
              <xsl:number level="any" value="count(/NATstyle/file[error/@severity ='info'])"/>
            </td>
          </tr>
          <tr bgcolor="#CCCCCC">
            <td>Files with warnings</td>
            <td align="center">
              <xsl:number level="any" value="count(/NATstyle/file[error/@severity ='warning'])"/>
            </td>
          </tr>
          <tr bgcolor="#CCFFCC">
            <td>Total errors</td>
            <td align="center">
              <xsl:number level="any" value="count(/NATstyle/file/error)"/>
            </td>
          </tr>
          <tr bgcolor="#CCCCCC">
            <td>Errors per file</td>
            <td>
              			  <xsl:number level="any" value="count(/NATstyle/file/error[@severity ='error']) div count(/NATstyle/file[error/@severity ='error'])  "/>
            </td>
          </tr>
          <tr bgcolor="#CCCCCC">
            <td>Warnings per file</td>
            <td>
			  <xsl:number level="any" value="count(/NATstyle/file/error[@severity ='warning']) div count(/NATstyle/file[error/@severity ='warning'])  "/>
            </td>
          </tr>
          <tr bgcolor="#CCCCCC">
            <td>Info per file</td>
            <td>
              <xsl:number level="any" value="count(/NATstyle/file/error[@severity ='info']) div count(/NATstyle/file[error/@severity ='info'])  "/>
            </td>
          </tr>
        </table>
        <hr align="left" width="95%" size="1"/>
        <p>The following are violations found:</p>
        <p/>
        <xsl:for-each select="/NATstyle/file[error]">
          <xsl:sort select="@type" order="descending" data-type="text"/>
          <xsl:sort select="@name" order="ascending" data-type="text"/>
          <table bgcolor="#33FF33" width="98%" border="1" cellspacing="0" cellpadding="2">
            <tr>
              <th nowrap="nowrap"> File (<xsl:value-of select="@type"/>): </th>
              <td>
                <xsl:value-of select="@location"/>
              </td>
            </tr>
          </table>
          <table bgcolor="#ccFFcc" width="98%" border="1" cellspacing="0" cellpadding="2">
            <tr>
              <th> Line </th>
              <th> Severity </th>
              <th> Message </th>
            </tr>
            <xsl:for-each select="error">
              <xsl:sort select="@line" order="ascending" data-type="number"/>
              <tr>
                <td width="5%" align="center">
                  <xsl:value-of select="@line"/>
                </td>
                <td width="10%" align="center">
                  <xsl:value-of select="@severity"/>
                </td>
                <td width="85%">
                  <xsl:value-of select="@message"/>
                </td>
              </tr>
            </xsl:for-each>
          </table>
          <p/>
        </xsl:for-each>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
