package org.codecop.natural.natstyle.pmd;

import net.sourceforge.pmd.Rule;
import net.sourceforge.pmd.RuleViolation;

/**
 * Minimal implementation of a PMD RuleViolation to create a report.
 */
public class NaturalRuleViolation implements RuleViolation {

    private final Rule rule;
    private final String description;
    private final String filename;
    private final int line;

    public NaturalRuleViolation(Rule rule, String description, String filename, int line) {
        this.rule = rule;
        this.description = description;
        this.filename = filename;
        this.line = line;
    }

    @Override
    public Rule getRule() {
        return rule;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public boolean isSuppressed() {
        return false;
    }

    @Override
    public String getFilename() {
        return filename;
    }

    @Override
    public int getBeginLine() {
        return line;
    }

    @Override
    public int getBeginColumn() {
        return 0;
    }

    @Override
    public int getEndLine() {
        return line;
    }

    @Override
    public int getEndColumn() {
        return 0;
    }

    @Override
    public String getPackageName() {
        return null;
    }

    @Override
    public String getClassName() {
        return null;
    }

    @Override
    public String getMethodName() {
        return null;
    }

    @Override
    public String getVariableName() {
        return null;
    }

}
