package org.codecop.natural.natstyle.util;

import java.io.IOException;
import java.io.UncheckedIOException;
import java.util.function.Consumer;

public class IO {

    public interface IOConsumer<T> {
        void accept(T t) throws IOException;
    }

    public static <T> Consumer<T> uncheck(IOConsumer<T> consumer) {
        return t -> {
            try {
                consumer.accept(t);
            } catch (IOException e) {
                throw new UncheckedIOException(e);
            }

        };
    }

}
